
#ifndef CLAMP_GENERAL_PLUGIN_H
#define CLAMP_GENERAL_PLUGIN_H

#include <AppKit.h>
#include <StorageKit.h>
#include <interface/View.h>

#ifndef CLAMP_PLUGIN_MSGS_H
 #include "Plugin_Messages.h"
#endif


// The following is for the GetFlags() return value
//  NO FLAGS YET!

// The class description of the object that will be returned when CL-Amp ask the AddOn (Plugin) for its object...
class GeneralPlugin {
public:
// Used by CL-Amp. Don't bother about these functions!
	GeneralPlugin(char *label, char *desc) { CLAmpHandler=NULL; Label= label; Description= desc; }
	virtual ~GeneralPlugin() { }
	void SetHandler(BView *handler) { CLAmpHandler= handler; }

// =================================================================
// Here comes the functions you have to provide in your plugin code!

// No thread considerations with this function!
	virtual bool Init()=0;
	virtual void Cleanup()=0;

// These functions will run in thread A, dont let functions from A use data from B or vice verse...
	virtual bool About(bool Question)=0;
	virtual bool Prefs(bool Question)=0;
	virtual unsigned long GetFlags()=0;

// End of the functions you have to provide in your plugin code!
// =================================================================

// Help functions you can call to get data from the InputPlugin class itself
	const char *GetLabel() { return Label; }
	const char *GetDescription() { return Description; }
	BHandler *GetCLAmpHandler() { return CLAmpHandler; }
	void SendToCLAmp_ChangedFile(const char *FileName) { BMessage Msg(CLAMP_MSG_CHANGED); BLooper *l; if (CLAmpHandler && (l=CLAmpHandler->Looper())) { Msg.AddString(CLAMP_CHANGED_LABEL, FileName); l->PostMessage (&Msg, CLAmpHandler); } }
	void SendToCLAmp_AddFile(const char *FileName) { BMessage Msg(CLAMP_MSG_ADD); BLooper *l; if (CLAmpHandler && (l=CLAmpHandler->Looper())) { Msg.AddString(CLAMP_ADD_LABEL, FileName); l->PostMessage (&Msg, CLAmpHandler); } }
	void SendToCLAmp_DelFile(const char *FileName) { BMessage Msg(CLAMP_MSG_DEL); BLooper *l; if (CLAmpHandler && (l=CLAmpHandler->Looper())) { Msg.AddString(CLAMP_DEL_LABEL, FileName); l->PostMessage (&Msg, CLAmpHandler); } }
private:
	char *Label, *Description;
	BView *CLAmpHandler;
};

#define CURRENT_GENERAL_PLUGIN_VERSION  1
#define GENERAL_PLUGIN_VERSION_MASK	0x0fff

#endif
