#define DONT_DEF_VERSION_ID Grr
#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <TextControl.h>
#include <Slider.h>
#include <Resources.h>
#include <Bitmap.h>

#include "ConfigView.h"
#include "MyScreenSaver.h"

static const char *NotRunningText= "Not running text";
static const char *NotPlayingText= "Not playing text";
static const char *WhichControlText= "WhichControl";

ConfigView::ConfigView(BView *view, MyScreenSaver *saver) :
	BView(view->Frame(), "TextFaderConfig", B_FOLLOW_ALL_SIDES, B_WILL_DRAW),
	mSaver(saver)
{
	SetViewColor(view->ViewColor());
	
	BRect rect(0, 0, Frame().right - 10, 0);
	BMessage NotRunningMsg(1);
	NotRunningMsg.AddString(WhichControlText, NotRunningText);

	char *txt = saver->GetNotRunningText();
	NoRunTextCtrl = new BTextControl(rect, NotRunningText, NotRunningText,
									txt, new BMessage(NotRunningMsg));
	if (txt) free(txt);
	rect.right += 5;
	//This message is sent for each keystroke in the TextControl.  The
	//modelMsg passed in BTextControl's constructor is only sent when the
	//focus leaves the TextControl (and is not sent if the user closes the
	//config dialogue with the focus still in the TextControl, even if the
	//text has changed).
	NoRunTextCtrl->SetModificationMessage(new BMessage(NotRunningMsg));
	NoRunTextCtrl->SetDivider(NoRunTextCtrl->StringWidth(NotRunningText) + 5);
	AddChild(NoRunTextCtrl);
	rect.OffsetBy(0, NoRunTextCtrl->Frame().Height() + 20);
	
	BMessage NotPlayingMsg(1);
	NotPlayingMsg.AddString(WhichControlText, NotPlayingText);

	txt = saver->GetNotPlayingText();
	NoPlayTextCtrl = new BTextControl(rect, NotPlayingText, NotPlayingText,
									txt, new BMessage(NotPlayingMsg));
	if (txt) free(txt);
	rect.right += 5;
	//This message is sent for each keystroke in the TextControl.  The
	//modelMsg passed in BTextControl's constructor is only sent when the
	//focus leaves the TextControl (and is not sent if the user closes the
	//config dialogue with the focus still in the TextControl, even if the
	//text has changed).
	NoPlayTextCtrl->SetModificationMessage(new BMessage(NotPlayingMsg));
	NoPlayTextCtrl->SetDivider(NoPlayTextCtrl->StringWidth(NotPlayingText) + 5);
	AddChild(NoPlayTextCtrl);
	rect.OffsetBy(0, NoPlayTextCtrl->Frame().Height() + 20);
	
	view->AddChild(this);
}

ConfigView::~ConfigView()
{
}

void ConfigView::AttachedToWindow()
{
	status_t st;

	st = NoPlayTextCtrl->SetTarget(this);
	st = NoRunTextCtrl->SetTarget(this);
}

void ConfigView::MessageReceived(BMessage *msg)
{
	const char *which;

	if (msg->what == 1 && (which = msg->FindString(WhichControlText))) {
		if (strcmp(which, NotRunningText) == 0)
			mSaver->SetNotRunningText(NoRunTextCtrl->Text());
		else if (strcmp(which, NotPlayingText) == 0)
			mSaver->SetNotPlayingText(NoPlayTextCtrl->Text());
	} else
		BView::MessageReceived(msg);
}
