#if !defined(INC_TEXTFADER)
#define INC_TEXTFADER 1

#include <vector>
#include <ScreenSaver.h>
#include <InterfaceKit.h>
#include "FrontEnd.h"
//class BBitmap;

#define MAXLEN 256


typedef struct ConfigData {
	char			NotRunningText[MAXLEN];
	char			NotPlayingText[MAXLEN];
} ConfigData;


class MyScreenSaver : public BScreenSaver
{
public:
					MyScreenSaver(BMessage *state, image_id image);
	virtual		   ~MyScreenSaver();
					
	char			*GetNotRunningText();
	void			SetNotRunningText(const char *text);
	char			*GetNotPlayingText();
	void			SetNotPlayingText(const char *text);
	image_id		GetImageId();
	
	//BScreenSaver overrides
	void			StartConfig(BView *view);
	void			StopConfig();
	status_t		SaveState(BMessage *state) const;	
	status_t		StartSaver(BView *view, bool preview);
	void			StopSaver();
	void			Draw(BView *view, int32 frame);
	
private:
	void			DecodeState(BMessage *state);
	ConfigData		Config;

	BLocker			ConfigLock;
	image_id		mImageId;
	CLAmp_FrontEnd *remote;
	int				ScreenHeight, ScreenWidth, YOffset;
	BView *DispView;
	BBitmap *DispBmp;
	long y, x, x_diff, y_diff;
};

#endif
